AJS.toInit(function ($)
{
    AJS.Gadget({
        baseUrl: contextPath,
        useOauth: "/rest/gadget/1.0/currentUser",
        view: {
            enableReload: true,
            onResizeAdjustHeight: true,
            template: function(args) {
                var gadget = this;
                var bodyHeight;
                // Allows you to do things like mystring.getHostname();
                String.prototype.getHostname = function() {
                    var re = new RegExp('^(?:f|ht)tp(?:s)?\://([^/]+)', 'im');
                    return this.match(re)[0].toString();
                };
                var hostname = contextPath.getHostname();
                var searchI18N = gadget.getMsg("gadget.quicknav.search");

                var focusSearch = function() {
                    var searchField = AJS.$("#gadget-search-query");
                    if (searchField.val() === searchI18N) {
                        searchField.val("").css("color", "#333");
                    }
                };
                var blurSearch = function() {
                    var searchField = AJS.$("#gadget-search-query");
                    if (searchField.val() === "") {
                        searchField.css("color", "#777").val(searchI18N);
                    }
                };
                var keydownSearch = function(e) {
                    if (e.which == 13 && AJS.$(".last a", searchField.next()) > 0) {
                        top.window.location = AJS.$(".last a", searchField.next()).attr("href");
                    }
                    return true;
                };
                var returnToBaseHeight = function() {
                    gadgets.window.adjustHeight(bodyHeight);
                };
                var ajsDropDownOptions = {
                    selectionHandler: function (e, selected) {
                        if (selected) {
                            if (selected.get(0).nodeName.toLowerCase() !== "a") {
                                top.window.location = selected.find("a").attr("href");
                            }
                            else {
                                top.window.location = selected.attr("href");
                            }
                            e.preventDefault();
                        }
                    },
                    escapeHandler: function () {
                        this.hide("escape");
                        returnToBaseHeight();
                        return false;
                    },
                    hideHandler: returnToBaseHeight
                };
                var options = {
                    ajsDropDownOptions: ajsDropDownOptions,
                    dropdownPostprocess: AJS.quicksearch.dropdownPostprocess
                };

                var onShow = function() {
                    AJS.$("a", this.$).each(function() {
                        var link = AJS.$(this).attr("href");
                        AJS.$(this).attr("target", "_parent").attr("href", hostname + link);
                    });
                    AJS.$("img", this.$).each(function() {
                        var link = AJS.$(this).attr("src");
                        AJS.$(this).attr("src", hostname + link);
                    });
                    AJS.$("div.aui-shadow").remove();
                    AJS.$(".dropdown-shim").remove();

                    var newHeight = bodyHeight;

                    // drop-down has top 3px in CSS
                    newHeight += 3;

                    // drop-down height
                    newHeight += this.$.height();

                    // top & bottom padding
                    newHeight += parseInt(this.$.css("padding-bottom"), 10) + parseInt(this.$.css("padding-top"),10);

                    gadgets.window.adjustHeight(newHeight);
                };
                var initGadget = function(data) {
                    try {
                        gadget.getView().append(AJS.$("#gadget-search").remove());
                        AJS.$("#gadget-search").show();
                        AJS.$("#quickSearchPlaceholder").attr("value", searchI18N);
                        var searchField = AJS.$("#gadget-search-query");
                        searchField.attr("value", searchI18N);
                        searchField.focus(focusSearch);
                        searchField.blur(blurSearch);
                        searchField.keydown(keydownSearch);
                        searchField.quicksearch("/json/contentnamesearch.action?query=", onShow, options);
                        AJS.$("#inline-dialog-shadow").remove();
                        AJS.$("#inline-dialog-shim").remove();

                        bodyHeight = AJS.$(".gadget").height();
                        // add height of the padlock button if it is visible
                        if (AJS.$(".footer button.oauth").length == 1)
                        {
                            bodyHeight += AJS.$(".footer").height();
                        }

                        AJS.$(document).click(returnToBaseHeight);
                        // Use a timeout to make resizing work more reliable
                        // (Should be using an "args" method instead)
                        window.setTimeout(function() {returnToBaseHeight();}, 150);
                    }
                    catch (e) {
                        AJS.log(e);
                    }
                };

                AJS.$.ajax({
                    url: contextPath + "/json/contentnamesearch.action?query=",
                    type: "GET",
                    dataType: "json",
                    success: initGadget,
                    error: function(err, text) {
                        AJS.log('OAuth error: ' + err + ': ' + text);
                    }
                });
            }
        }
    })
});