jQuery(document).ready(
        function()
        {
            var pluginCompatibilityMatrix = {
                
                getFieldSetAsMap : function(fieldset)
                {
                    var inputParams =  {};
                    fieldset.children("input").each(
                            function()
                            {
                                inputParams[jQuery(this).attr("name")] = jQuery(this).attr("value");
                            }
                    );

                    return inputParams;
                },

                makeQuestionMarksShowCompatibilityDetailOnClick : function()
                {
                    jQuery(".pluginIncompatibilityIconLink").each(
                            function()
                            {
                                jQuery(this).click(
                                        function(e)
                                        {
                                            var jQueryThis = jQuery(this);
                                            var inputParams = pluginCompatibilityMatrix.getFieldSetAsMap(jQueryThis.siblings("fieldset"));

                                            var detailParagraph = jQueryThis.siblings("div.apr-compat-details");

                                            if (detailParagraph.length > 0)
                                            {
                                                detailParagraph.remove();
                                            }
                                            else
                                            {
                                                jQueryThis.parent().append("<div class='apr-compat-details'>" + inputParams['compatibilityDetailsHtml'] + "</div>");
                                            }

                                            return false;
                                        }
                                );
                            }
                    );
                },

                makeShowInfoHyperLinksToggleCompatibilityMatrixDetail : function()
                {
                    var aprCompatibilityMatrixContainer = jQuery("div.apr-compat-matrix-container");

                    aprCompatibilityMatrixContainer.append("<a class='apr-compat-matrix-toggle-info-link'></a>");
                    aprCompatibilityMatrixContainer.children("a.apr-compat-matrix-toggle-info-link").each(
                            function()
                            {
                                var jQueryThis = jQuery(this);
                                var fieldset = jQueryThis.siblings("fieldset");
                                var inputParams =  pluginCompatibilityMatrix.getFieldSetAsMap(fieldset);

                                jQueryThis.attr("href", "#");

                                if (inputParams['showingMajorVersionsOnly'] == "true")
                                {
                                    jQueryThis.text(inputParams['i18n_showMoreInfo']);
                                }
                                else
                                {
                                    jQueryThis.text(inputParams['i18n_showLessInfo']);
                                }

                                jQueryThis.click(
                                        function()
                                        {
                                            var jQueryThis = jQuery(this);
                                            var fieldset = jQueryThis.siblings("fieldset");
                                            var inputParams =  pluginCompatibilityMatrix.getFieldSetAsMap(fieldset);
                                            var showingMajorVersionsOnly = false;

                                            showingMajorVersionsOnly = inputParams['showingMajorVersionsOnly'];
                                            if (showingMajorVersionsOnly == "true")
                                            {
                                                fieldset.children("input[name='showingMajorVersionsOnly']").attr("value", "false");
                                                jQueryThis.siblings("div.apr-compat-matrix-table").each(
                                                        function()
                                                        {
                                                            jQuery(this).html(inputParams['fullMatrixHtml']);
                                                        }
                                                );
                                                
                                                jQueryThis.html(inputParams['i18n_showLessInfo']);
                                            }
                                            else
                                            {
                                                fieldset.children("input[name='showingMajorVersionsOnly']").attr("value", "true");

                                                jQueryThis.siblings("div.apr-compat-matrix-table").each(
                                                        function()
                                                        {
                                                            jQuery(this).html(inputParams['majorVersionsOnlyMatrixHtml']);
                                                        }
                                                );
                                                jQueryThis.html(inputParams['i18n_showMoreInfo']);
                                            }

                                            pluginCompatibilityMatrix.makeQuestionMarksShowCompatibilityDetailOnClick();
                                            return false;
                                        }
                                );
                            }
                    );

                }
            };

            pluginCompatibilityMatrix.makeQuestionMarksShowCompatibilityDetailOnClick();
            pluginCompatibilityMatrix.makeShowInfoHyperLinksToggleCompatibilityMatrixDetail();
        }
)